#include "stdafx.h"
#include "RelRec.h"
#include "RelRecDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define NL	_T("\r\n")

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CRelRecDlg dialog




CRelRecDlg::CRelRecDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRelRecDlg::IDD, pParent)
	, m_ModuleName(_T("C:\\Test.dll"))
	, m_Log(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRelRecDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_ModuleName, m_ModuleName);
	DDX_Text(pDX, IDC_Log, m_Log);
	DDX_Control(pDX, IDC_Log, m_LogCtrl);
}

BEGIN_MESSAGE_MAP(CRelRecDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_ModuleNameOpenButton, &CRelRecDlg::OnBnClickedModulenameopenbutton)
	ON_BN_CLICKED(IDOK, &CRelRecDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CRelRecDlg message handlers

BOOL CRelRecDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRelRecDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRelRecDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRelRecDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

BOOL GetFileName(BOOL IsOpen, CString &FileName, const CString& Filter)
{
	ULONG lFlags = OFN_HIDEREADONLY | OFN_EXPLORER;
	if (IsOpen)
	{
		lFlags |= OFN_FILEMUSTEXIST;
	}
	else
	{
		lFlags |= OFN_OVERWRITEPROMPT;
	}
	CFileDialog lDlg(IsOpen, FileName, 0,  lFlags, Filter);
	if (lDlg.DoModal() != IDOK) return FALSE;
	FileName = lDlg.GetPathName();
	return TRUE;
}

BOOL GetFileName(BOOL IsOpen, CString &FileName)
{
	return GetFileName(IsOpen, FileName, _T("Dynamic Libraries (*.dll)|*.dll|All files (*.*)|*.*||"));
}

void CRelRecDlg::OnBnClickedModulenameopenbutton()
{
	CString lDllName(_T("*.dll"));
	if (!GetFileName(TRUE, lDllName))
		return;

	m_ModuleName = lDllName;
	UpdateData(FALSE);
}

bool GetPathFromFullName(CString& Path, const CString& FullName)
{
	if (FullName.IsEmpty())
		return false;

	int lPos = FullName.ReverseFind(_T('\\'));
	if (lPos == -1)
		return false;

	Path = FullName.Left(lPos);
	return true;
}

bool IsFileExists(const CString& FileName)
{
	CFile lFile;
	
	bool lResult = lFile.Open(FileName, CFile::typeBinary | CFile::modeRead | CFile::shareDenyNone, NULL) == TRUE;
	if (lResult)
		lFile.Close();

	return lResult;
}

bool GetUniqueFileName(const CString& Base, CString& Name)
{
	static int lIndex = 0;
	CString lPrefix, lSuffix;
	int lDotPos = Base.ReverseFind(_T('.'));

	/* If no dot, just append unique number.  */
	if (lDotPos == -1)
		lDotPos = Base.GetLength();

	do {
		lPrefix = Base.Left(lDotPos);
		lSuffix = Base.Right(Base.GetLength() - lDotPos);
		lPrefix.AppendFormat(_T("-%08x"), lIndex++);
		lPrefix.Append(lSuffix);

	} while (IsFileExists(lPrefix));
	
	Name = lPrefix;
	return true;
}

void CleanupEnvironment(HMODULE& Dll0, HMODULE& Dll1)
{
	if (Dll1)
	{
		::FreeLibrary(Dll1);
		Dll1 = NULL;
	}
	if (Dll0)
	{
		::FreeLibrary(Dll0);
		Dll0 = NULL;
	}
}

bool PrepareEnvironment(CString& FileName, HMODULE& Dll0, HMODULE& Dll1, CString& Log)
{
	bool lResult = false;
	CString lFile0, lFile1;
	HMODULE lDll0 = NULL, lDll1 = NULL;

	if (!GetUniqueFileName(FileName, lFile0)
	 || !GetUniqueFileName(FileName, lFile1))
	{
		Log += _T(" ! Can not make unique filename for ");
		Log += FileName;
		Log += NL;
		goto l_Exit;
	}
	Log += _T(" ~ File[0] = \"");
	Log += lFile0;
	Log += _T("\", File[1] = \"");
	Log += lFile1;
	Log += _T("\"") NL;

	if (!::CopyFile(FileName, lFile0, TRUE))
	{
		Log += _T(" ! File \"");
		Log += lFile0;
		Log += _T("\" already exists.");
		Log += NL;
		goto l_Exit;
	}

	if (!::CopyFile(FileName, lFile1, TRUE))
	{
		Log += _T(" ! File \"");
		Log += lFile1;
		Log += _T("\" already exists.");
		Log += NL;
		goto l_Exit;
	}

	lDll0 = ::LoadLibrary(lFile0);
	if (!lDll0)
	{
		Log += _T(" ! Can not load \"");
		Log += lFile0;
		Log += _T("\"") NL;
		Log.AppendFormat(_T(" ! ErrorCode: 0x%08x") NL, ::GetLastError());
		goto l_Exit;
	}

	lDll1 = ::LoadLibrary(lFile1);
	if (!lDll1)
	{
		Log += _T(" ! Can not load \"");
		Log += lFile1;
		Log += _T("\"") NL;
		Log.AppendFormat(_T(" ! ErrorCode: 0x%08x") NL, ::GetLastError());
		goto l_Exit;
	}

	Log.AppendFormat(_T(" * Bases are (0x%08x, 0x%08x)") NL, lDll0, lDll1);
	Dll0 = lDll0;
	Dll1 = lDll1;
	lResult = true;

l_Exit:;
	if (!lResult)
		CleanupEnvironment(lDll0, lDll1);

	return lResult;
}

typedef	USHORT					Rel32Item;
typedef std::vector<Rel32Item>	Rel32Items;
typedef std::map<ULONG, Rel32Items> Rel32Records;

void SerializeWordToBytes(bytes_t& Result, USHORT Value)
{
	Result.push_back(Value & 0xff); Value >>= 8;
	Result.push_back(Value & 0xff); Value >>= 8;
}

void SerializeDwordToBytes(bytes_t& Result, ULONG Value)
{
	Result.push_back(Value & 0xff); Value >>= 8;
	Result.push_back(Value & 0xff); Value >>= 8;
	Result.push_back(Value & 0xff); Value >>= 8;
	Result.push_back(Value & 0xff); Value >>= 8;
}

void SerializeRel32ItemsToBytes(bytes_t& Result, const Rel32Items& Value)
{
	for (Rel32Items::const_iterator e = Value.end(), i = Value.begin(); i != e; ++i)
		SerializeWordToBytes(Result, *i | 0x3000);
}

void SerializeRel32Records(bytes_t& Result, const Rel32Records& Data)
{
	bytes_t lResult;
	for (Rel32Records::const_iterator e = Data.end(), i = Data.begin(); i != e; ++i)
	{
		SerializeDwordToBytes(lResult, i->first);

		bool lIsAlignRequired = (i->second.size() & 1) == 1;
		ULONG lAlignSize = lIsAlignRequired ? sizeof(Rel32Item) : 0;

		SerializeDwordToBytes(lResult, i->second.size() * sizeof(Rel32Item) + 2 * sizeof(ULONG) + lAlignSize);
		SerializeRel32ItemsToBytes(lResult, i->second);

		if (lIsAlignRequired)
			SerializeWordToBytes(lResult, 0x0000);
	}
	Result.swap(lResult);
}

void AddRelocItem32(Rel32Records& Relocs, ULONG Base, Rel32Item Offset)
{
	Rel32Records::iterator lItemPos = Relocs.find(Base);
	if (lItemPos == Relocs.end())
		Relocs.insert(make_pair(Base, Rel32Items()));
	Relocs[Base].push_back(Offset);
}

void CollectRelocations(const HMODULE& Dll0, const HMODULE& Dll1, bytes_t& Result, CString& Log)
{
	Rel32Records lRelocs;

	PUCHAR lBasePtr[] = { (PUCHAR) Dll0, (PUCHAR) Dll1 };
	PIMAGE_DOS_HEADER lDosHeader = (PIMAGE_DOS_HEADER) lBasePtr[0];
	PIMAGE_NT_HEADERS lNtHeader = (PIMAGE_NT_HEADERS) (lBasePtr[0] + lDosHeader->e_lfanew);
	PIMAGE_SECTION_HEADER lSections = IMAGE_FIRST_SECTION(lNtHeader);
	WORD lNumberOfSections = lNtHeader->FileHeader.NumberOfSections;

	ULONG lBaseMask = reinterpret_cast<ULONG>(lBasePtr[0]) ^ reinterpret_cast<ULONG>(lBasePtr[1]);
	ULONG lDiff = sizeof(ULONG);
	if (((lBaseMask >> 0x18) & 0xff) == 0)
	{
		--lDiff;
		if (((lBaseMask >> 0x10) & 0xff) == 0)
		{
			Log.AppendFormat(_T(" ! DLLs bases are invalid.") NL);
			return;
		}
	}
	Log.AppendFormat(_T(" ~ Relocs diff value is %d") NL, lDiff);

	ULONG lBaseDiff = lBasePtr[1] - lBasePtr[0];

	for (int i = 0; i < lNumberOfSections; ++i)
	{
		char lSectionName[IMAGE_SIZEOF_SHORT_NAME + 1];
		memset(lSectionName, 0, sizeof(lSectionName));
		memcpy_s(lSectionName, sizeof(lSectionName), lSections[i].Name, IMAGE_SIZEOF_SHORT_NAME);
		ULONG lSectionAddr = lSections[i].VirtualAddress;
		ULONG lSectionSize = lSections[i].SizeOfRawData;
		ULONG lSectionAttr = lSections[i].Characteristics;

		Log.AppendFormat(_T(" ~ Checking section %s [Addr = 0x%08x, Size = 0x%08x (%d), Attr = 0x%08x]") NL, lSectionName, lSectionAddr, lSectionSize, lSectionSize, lSectionAttr);

		PUCHAR lSectionBase[] = { lBasePtr[0] + lSectionAddr, lBasePtr[1] + lSectionAddr };
		PUCHAR lDataPtr[] = { lSectionBase[0], lSectionBase[1] };
		bool lIsInreloc = false;
		
		for (ULONG j = 0; j < lSectionSize; ++j)
		{
			// Log.AppendFormat(_T(" ~ (0x%08x, 0x%08x) = (0x%02x, 0x%02x)") NL, lDataPtr[0] + j, lDataPtr[1] + j, lDataPtr[0][j], lDataPtr[1][j]);
			if (lDataPtr[0][j] != lDataPtr[1][j])
			{
				lIsInreloc = true;
				continue;
			}

			if (!lIsInreloc)
				continue;

			lIsInreloc = false;

			/* Check for the false positive.  */
			ULONG lRelocatedValues[] = { *reinterpret_cast<PULONG>(&lDataPtr[0][j - lDiff]), *reinterpret_cast<PULONG>(&lDataPtr[1][j - lDiff]) };
			ULONG lRelocatedValuesDiff = lRelocatedValues[1] - lRelocatedValues[0];
			if (lRelocatedValuesDiff != lBaseDiff)
				continue;

			/* We are at the end of reloc item.  */
			ULONG lRelocValue = lSectionAddr + j - lDiff;
			AddRelocItem32(lRelocs, lRelocValue & ~0xfff, lRelocValue & 0xfff);
		}
	}

	SerializeRel32Records(Result, lRelocs);
}

void CRelRecDlg::OnBnClickedOk()
{
	UpdateData(TRUE);
	m_Log = _T(" ~ Processing...") NL;

	HMODULE lDll0 = NULL, lDll1 = NULL;
	if (PrepareEnvironment(m_ModuleName, lDll0, lDll1, m_Log))
	{
		bytes_t lResult;
		CollectRelocations(lDll0, lDll1, lResult, m_Log);

		if (!lResult.empty())
		{
			CString lResultFileName(m_ModuleName + _T(".relocs"));
			CFile lResultFile;

			if (lResultFile.Open(lResultFileName, CFile::modeCreate | CFile::typeBinary | CFile::modeWrite, NULL))
			{
				lResultFile.Write(&lResult[0], lResult.size());
				lResultFile.Close();
			}
			else
			{
				m_Log += _T(" ! Can not create result file.") NL;
			}
		}

		CleanupEnvironment(lDll0, lDll1);
	}

	m_Log += _T(" ~ Done.") NL;
	UpdateData(FALSE);
}
